package de.fitconnect.client;

import de.fitconnect.api.Sender;
import de.fitconnect.api.auth.OAuthToken;
import de.fitconnect.api.auth.OAuthService;
import de.fitconnect.api.data.Data;
import de.fitconnect.api.data.Metadata;
import de.fitconnect.api.validation.ValidationResult;

import java.io.ByteArrayInputStream;

public class SubmissionSender implements Sender {

    private final OAuthService authService;

    public SubmissionSender(final OAuthService authService){
        this.authService = authService;
    }

    @Override
    public OAuthToken retrieveAuthenticationToken(String clientId, String clientSecret, String scope) {
        return authService.authenticate(clientId, clientSecret, scope).orElseThrow();
    }

    @Override
    public ValidationResult validateCertificateChain(byte[] chain) {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public Data encryptData(Data unencryptedData) {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public ByteArrayInputStream encryptAttachment(ByteArrayInputStream unencryptedAttachmentBinary) {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public Metadata generateMetadata(byte[] attachment) {
        throw new UnsupportedOperationException("Not yet implemented");
    }
}
